# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# MCT - Mini Cliente Torrent para pelisalacarta
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os
import sys

import libtorrent as lt

import xbmc
import xbmcgui

from platformcode.xbmc import xbmctools
from platformcode.xbmc import library

from core import scrapertools
from core import config
#from core import logger
#from core.item import Item

def play(url, is_view=None):

    if not url.endswith(".torrent") and not url.startswith("magnet"):
        t_file = scrapertools.get_header_from_response(url,header_to_get="location")
        if len(t_file) > 0:
            url = t_file

    # -- Crear dos carpetas en descargas para los archivos ------
    save_path_videos = os.path.join( config.get_setting("downloadpath") , "torrent-videos" )
    save_path_torrents = os.path.join( config.get_setting("downloadpath") , "torrent-torrents" )
    if not os.path.exists( save_path_torrents ): os.mkdir(save_path_torrents)

    # -- Usar - archivo torrent desde web, meagnet o HD ---------
    if not os.path.isfile(url) and not url.startswith("magnet"):
        # -- http - crear archivo torrent -----------------------
        data = url_get(url)

        # -- El nombre del torrent será el que contiene en los --
        # -- datos.                                             -
        re_name_len = int( scrapertools.get_match(data,':name(\d+):') )
        re_name = library.title_to_folder_name( urllib.unquote( scrapertools.get_match(data,':name\d+:([^:]+):') ) )
        torrent_file = os.path.join(save_path_torrents, re_name[:(re_name_len-1)]+'.torrent')

        f = open(torrent_file,'wb')
        f.write(data)
        f.close()
    elif os.path.isfile(url):
        # -- file - para usar torrens desde el HD ---------------
        torrent_file = url
    else:
        # -- magnet ---------------------------------------------
        torrent_file = url

        # -- Crear torrent desde magnet - Dudas en integrarlo ---
        # -- Tarda lo mismo, de 3 a 5 minutos, en conseguir los -
        # -- metadata, tanto con lo que hay comentado como usar -
        # -- el parámetro 'url':torrent_file para los enlaces   -
        # -- torrent.                                           -
        '''
        import shutil
        import tempfile

        magnet = url
        tempdir = tempfile.mkdtemp()

        ses = lt.session()

        params = {
            'save_path': tempdir,
            'duplicate_is_error': True,
            'storage_mode': lt.storage_mode_t(2),
            'paused': False,
            'auto_managed': True,
            'duplicate_is_error': True
        }

        h = lt.add_magnet_uri( ses, magnet, params )

        dp = xbmcgui.DialogProgress()
        dp.create('pelissalacarta-MCT')

        while not h.has_metadata():

            s = h.status()
            state_str = ['queued', 'checking', 'downloading metadata', \
                'downloading', 'finished', 'seeding', 'allocating', 'checking fastresume']

            message = '%.2f%% d:%.1f kb/s u:%.1f kB/s p:%d s:%d %s' % \
                (s.progress * 100, s.download_rate / 1000, s.upload_rate / 1000, \
                s.num_peers, s.num_seeds, state_str[s.state])
            porcent = int( s.progress * 100 )

            dp.update(porcent, message)

            if dp.iscanceled():
                dp.close()
                ses.remove_torrent( h )
                shutil.rmtree( tempdir )
                return []

            time.sleep(1)

        dp.close()

        info = h.get_torrent_info()
        data = lt.create_torrent( info )

        torrent_file = os.path.join( save_path_torrents, library.title_to_folder_name( info.name() ) + ".torrent" )

        f = open( torrent_file, "wb" )
        f.write( lt.bencode( data.generate() ) )
        f.close()

        ses.remove_torrent( h )
        shutil.rmtree( tempdir )
        '''
    # -----------------------------------------------------------

    # -- MCT - MiniClienteTorrent -------------------------------
    ses = lt.session()
    ses.listen_on(6881, 6891)

    video_file = ""
    if not torrent_file.startswith("magnet"):
        # -- Archivos torrent -----------------------------------
        e = lt.bdecode(open(torrent_file, 'rb').read())
        info = lt.torrent_info(e)

        # -- El más gordo se entiende que es el vídeo -----------
        video_file = get_video_file(info)

        h = ses.add_torrent( { 'ti':info, 'save_path': save_path_videos, 'storage_mode':lt.storage_mode_t.storage_mode_allocate } )
    else:
        # -- Enlaces magnet -------------------------------------
        # -- Se intentará quitar esta opción. Si se crea un     -
        # -- .torrent con el magnet, la descarga será mucho más -
        # -- rápida                                             -
        h = ses.add_torrent( { 'url':torrent_file, 'save_path': save_path_videos, 'storage_mode':lt.storage_mode_t.storage_mode_allocate } )

    # -- Descarga secuencial - trozo 1, trozo 2, ... ------------
    h.set_sequential_download(True)

    # -- Crear diálogo de progreso para el primer bucle ---------
    dp = xbmcgui.DialogProgress()
    dp.create('pelissalacarta-MCT')

    # -- Doble bucle anidado ------------------------------------
    # -- Descarga - Primer bucle                                -
    while not h.is_seed():

        # -- Recuperar los datos del progreso -------------------
        message, porcent, msg_file, s, download = getProgress(h, video_file)

        #print message

        # -- Si hace 'checking' existe descarga -----------------
        # -- 'download' Se usará para saber si hay datos        -
        # -- descargados para el diálogo de 'remove_files'      -
        if s.state == 1: download = 1

        # -- Si es un magnet viene sin nombre de video ----------
        # -- Se necesita el nombre del video para player        -
        if video_file == "" and s.state == 3:
            # -- El más gordo se entiende que es el vídeo -------
            info = h.get_torrent_info()
            video_file = get_video_file(info)

        # -- Player - play --------------------------------------
        # -- Opción 1 - Estimar cuando se comenzará el ----------
        # -- visionado. (algoritmo al gusto 1)                  -
        estimed = int( s.total_wanted / 1048576.0 ) / 10
        rate = int( s.download_rate / 1000 )
        option1 = ( rate > estimed )

        print "### estimed: %s" % estimed
        print "### rate: %s" % rate

        # -- Opción 2 - Estimar cuando se comenzará el ----------
        # -- visionado. (algoritmo al gusto 2)                  -
        option2 = ( porcent >= 1 )

        # -- Player - play --------------------------------------
        if (option1 and is_view != "Ok" and s.state == 3) or s.state == 1:
            is_view = "Ok"
            dp.close()

            # -- Player - Ver el vídeo --------------------------
            player = play_video()
            player.play( os.path.join( save_path_videos, video_file ) )

            # -- Segundo bucle - Player - Control de eventos ----
            while player.isPlaying():
                xbmc.sleep(100)

                # -- Cerrar el diálogo de progreso --------------
                if player.resumed:
                    dp.close()

                # -- Mostrar el diálogo de progreso -------------
                if player.paused:
                    # -- Crear diálogo si no existe -------------
                    if not player.statusDialogoProgress:
                        dp = xbmcgui.DialogProgress()
                        dp.create('pelissalacarta-MCT')
                        player.setDialogoProgress()

                    # -- Diálogos de estado en el visionado -----
                    if not h.is_seed():
                        # -- Recuperar los datos del progreso ---
                        message, porcent, msg_file, s, download = getProgress(h, video_file)
                        dp.update(porcent, message, msg_file)
                    else:
                        dp.update(100, "Descarga completa: " + video_file)

                    # -- Se canceló el progreso en el visionado -
                    # -- Continuar                              -
                    if dp.iscanceled():
                        dp.close()
                        player.pause()

        # -- Kodi - Se cerró el visionado -----------------------
        # -- Terminar                                           -
        if is_view == "Ok" and not xbmc.Player().isPlaying():
            # -- Diálogo eliminar archivos ----------------------
            remove_files( download, torrent_file, video_file, ses, h )
            return

        # -- Mostar progeso antes del visionado -----------------
        if is_view != "Ok" :
            dp.update(porcent, message, msg_file)

        # -- Se canceló el progreso antes del visionado ---------
        # -- Terminar                                           -
        if dp.iscanceled():
            dp.close()
            # -- Diálogo eliminar archivos ----------------------
            remove_files( download, torrent_file, video_file, ses, h )
            return

    # -- Kodi - Error? - No debería llegar aquí -----------------
    if is_view == "Ok" and not xbmc.Player().isPlaying():
        dp.close()
        # -- Diálogo eliminar archivos --------------------------
        remove_files( download, torrent_file, video_file, ses, h )

    return

# -- Progreso de la descarga ------------------------------------
def getProgress(h, video_file):

    s = h.status()

    state_str = ['queued', 'checking', 'downloading metadata', \
        'downloading', 'finished', 'seeding', 'allocating', 'checking fastresume']

    message = '%.2f%% d:%.1f kb/s u:%.1f kB/s p:%d s:%d %s' % \
        (s.progress * 100, s.download_rate / 1000, s.upload_rate / 1000, \
        s.num_peers, s.num_seeds, state_str[s.state])
    porcent = int( s.progress * 100 )

    download = ( s.progress * 100 )

    if "/" in video_file: name_video_file = video_file.split("/")[1]
    msg_file = ".../" + name_video_file + " (%.2f)" % (s.total_wanted/1048576.0)

    return (message, porcent, msg_file, s, download)

# -- Clase play_video - Controlar eventos -----------------------
class play_video(xbmc.Player):

    def __init__( self, *args, **kwargs ):
        self.paused = False
        self.resumed = True
        self.statusDialogoProgress = False
        #self.started = False
        #self.ended = False
        #self.stopped = False

    def onPlayBackPaused(self):
        self.paused = True
        self.resumed = False

    def onPlayBackResumed( self ):
        self.paused = False
        self.resumed = True
        self.statusDialogoProgress = False

    #def onPlayBackStarted
    #    self.started = True

    #def onPlayBackEnded
    #    self.ended = True

    #def onPlayBackStopped
    #    self.stopped = True

    def is_paused(self):
        return self.paused

    def setDialogoProgress(self):
        self.statusDialogoProgress = True

    #def is_started
    #    return self.started

    #def is_ended
    #    return self.ended

    #def is_stopped
    #    return self.stopped

# -- Conseguir el nombre del alchivo de vídeo del metadata ------
# -- El más gordo se entiende que es el vídeo                    
def get_video_file( info ):
    size_file = 0
    for f in info.files():
        if f.size > size_file:
            video_file = f.path.replace("\\","/")
            size_file = f.size
    return video_file

# -- Preguntar si se desea borrar lo descargado -----------------
def remove_files( download, torrent_file, video_file, ses, h ):

    dialog_view = False
    torrent = False

    if os.path.isfile( torrent_file ):
        dialog_view = True
        torrent = True

    if download > 0:
        dialog_view = True

    if "/" in video_file: video_file = video_file.split("/")[0]

    if dialog_view:
        d = xbmcgui.Dialog()
        ok = d.yesno('pelissalacarta-MCT', 'Borrar las descargas del video', video_file)

        # -- SI -------------------------------------------------
        if ok:
            # -- Borrar archivo - torrent -----------------------
            if torrent:
                os.remove( torrent_file )
            # -- Borrar carpeta/archivos y sesión - vídeo -------
            ses.remove_torrent( h, 1 )
        else:
            # -- Borrar sesión ----------------------------------
            ses.remove_torrent( h )
  
    return

# -- Descargar de la web los datos para crear el torrent --------
# -- Si queremos aligerar el script mct.py se puede importar la -
# -- función del conentor torrent.py                            -
def url_get(url, params={}, headers={}):
    from contextlib import closing

    USER_AGENT = "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.8; rv:20.0) Gecko/20100101 Firefox/20.0"

    if params:
        import urllib
        url = "%s?%s" % (url, urllib.urlencode(params))

    req = urllib2.Request(url)
    req.add_header("User-Agent", USER_AGENT)
    for k, v in headers.items():
        req.add_header(k, v)

    try:
        with closing(urllib2.urlopen(req)) as response:
            data = response.read()
            if response.headers.get("Content-Encoding", "") == "gzip":
                import zlib
                return zlib.decompressobj(16 + zlib.MAX_WBITS).decompress(data)
            return data
    except urllib2.HTTPError:
        return None
